
/* Main namespace. */
com.extrabux.extensions.Extrabux.options = (function (my) {

  var $ = my.$;

  var NS = {};

  Components.utils.import("resource://extrabux/modules/logging.jsm", NS);
  Components.utils.import("resource://extrabux/modules/underscore.jsm", NS);

  var _ = NS._;

  var controllersNS = {};
  Components.utils.import("resource://extrabux/modules/optionsController.jsm", controllersNS);

  var viewsNS = {};
  Components.utils.import("resource://extrabux/modules/options.jsm", viewsNS);


  my.MVCInfo = {};
  my.MVCInfo.views = {
    Options: new viewsNS.Options(window, null, {}, $)
  };
  my.MVCInfo.controllers = {
    Options: new controllersNS.Options(window, {}, my.MVCInfo.views, $)
  };


  my.initialize = function() {
    my.MVCInfo.controllers.Options.onLoad();
  };


  my.finalize = function() {
    _.each(my.MVCInfo.views, function(view) {
      view.destroy();
    });
    _.each(my.MVCInfo.controllers, function(controller) {
      controller.tabClosed();
    });
    my.MVCInfo = {};
    NS.logger.debug("Options -> finalized");
  };

  return my;

}(com.extrabux.extensions.Extrabux.options || {}));


//window.addEventListener("load", function () { com.extrabux.extensions.Extrabux.options.initialize(); }, false);
window.addEventListener("load", function () { com.extrabux.extensions.Extrabux.options.initialize(); }, false);
window.addEventListener("unload", function () { com.extrabux.extensions.Extrabux.options.finalize(); }, false);
window.addEventListener("pagehide", function () { com.extrabux.extensions.Extrabux.options.finalize(); }, false);
