var EXPORTED_SYMBOLS = ["Click"];


var Ci = Components.interfaces;
var Cc = Components.classes;
var Cu = Components.utils;


Cu.import("resource://extrabux/modules/logging.jsm");
var nativeJSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);


Cu.import("resource://extrabux/modules/underscore.jsm");
Cu.import("resource://extrabux/modules/inheritFrom.jsm");

Cu.import("resource://extrabux/modules/xmlHttpWrapper.jsm");


Cu.import("resource://extrabux/modules/config.jsm");
Cu.import("resource://extrabux/modules/utils.jsm");


  // Base URL for all Store-API-related requests.
var baseURL = Config.baseURL + "click/";


/*
* The model for stores.
* Wraps the communication with the Extrabux API.
*/
function Click() {
  // Remember whether we generated a click for the current site (necessary in
  // order not to generate a click when user closes the notif bar and has
  // already generated one earlier).
  this.generatedForCurrentSite = false;
}


InheritFrom(XMLHTTPWrapper, Click);


Click.prototype.storeLoaded = function() {
  logger.debug("Click -> storeLoaded");
  this.generatedForCurrentSite = false;
};


Click.prototype.generateClick = function(params, callbackObj) {
  logger.debug("Click model -> generateClick");
  var self = this;

  this._post(baseURL, {}, params, {on: {
    success: function(response) {
      logger.debug("Click model -> generateClick -> success (setting flag)");
      self.generatedForCurrentSite = true;
      if (callbackObj) {
        callbackObj.on.success(response);
      }
    },
    error: function(reason) {
      if (callbackObj) {
        callbackObj.on.error(reason);
      }
    }
  }});
};
