var EXPORTED_SYMBOLS = ["DelayedAction"];

var Cc = Components.classes;
var Cu = Components.utils;
var Ci = Components.interfaces;


Cu.import("resource://extrabux/modules/logging.jsm");
Cu.import("resource://extrabux/modules/underscore.jsm");


function DelayedAction() {
  this._actions = [];
}

DelayedAction.prototype.addAction = function(actionFun) {
  this._actions.push(actionFun);
};

DelayedAction.prototype.clear = function() {
  this._actions = [];
};

DelayedAction.prototype.fire = function() {
  _.each(this._actions, function(fun) {
    fun();
  });
};
