
var EXPORTED_SYMBOLS = ["Event"];

var Cc = Components.classes;
var Cu = Components.utils;
var Ci = Components.interfaces;


Cu["import"]("resource://extrabux/modules/underscore.jsm");
Cu["import"]("resource://extrabux/modules/logging.jsm");

/**
 *  Little class for implementing the subscriber pattern.
 */
var Event = function (sender) {
    this._sender = sender;
    this._listeners = [];
};

Event.prototype = {
    attach : function (listener) {
        var fn = function(sender, args) {
          return listener(sender, args);
        };
        if (this._listeners.indexOf(fn) < 0) {
          this._listeners.push(fn);
        }
        return fn;
    },

    detach : function (id) {
      logger.debug("Listeners before detach: " + this._listeners.length);
      this._listeners = _.without(this._listeners, id);
      logger.debug("Listeners after detach: " + this._listeners.length);
    },

    notify : function (args) {
        for (var i = 0; i < this._listeners.length; i++) {
          try {
            this._listeners[i](this._sender, args);
          } catch(e) {
            logger.error("Event -> notify: " + e);
          }
        }
    }
};


