
var EXPORTED_SYMBOLS = ["FacebookLoginManager"];


var Cc = Components.classes;
var Cu = Components.utils;
var Ci = Components.interfaces;


Cu["import"]("resource://extrabux/modules/utils.jsm");
var _txt = Utils.text;


Cu["import"]("resource://extrabux/modules/logging.jsm");
var nativeJSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
Cu["import"]("resource://extrabux/modules/underscore.jsm");

Cu["import"]("resource://extrabux/modules/event.jsm");
Cu["import"]("resource://extrabux/modules/inheritFrom.jsm");
Cu["import"]("resource://extrabux/modules/config.jsm");
Cu["import"]("resource://extrabux/modules/xmlHttpWrapper.jsm");


Cu["import"]("resource://extrabux/modules/genericLoginManager.jsm");



function FacebookLoginManager(browser, $) {
  FacebookLoginManager.baseConstructor.call(this, browser, $);

  this._id = "facebook";
  this.FBPageLoadHandle = null;
}


/* Inherit the HTTP voodoo. */
InheritFrom(GenericLoginManager, FacebookLoginManager);


FacebookLoginManager.prototype.__defineGetter__("id", function() {
  return this._id;
});


FacebookLoginManager.prototype.authenticate = function(username, password, callbackObj) {
  var self = this;

  var fbBrowser = this.$("#extrabux-facebook-login-browser");

  logger.debug("FacebookLoginManager -> authenticate");

  fbBrowser.get(0).removeEventListener("DOMContentLoaded", this.FBPageLoadHandle, false);

  this.FBPageLoadHandle = function handleLoad(event) {
    var pageIsFrame = (event.target instanceof Ci.nsIDOMHTMLDocument &&
      event.target != fbBrowser.get(0).contentDocument);
    if (pageIsFrame) {
      // Not interested in frames.
      return;
    }

    var doc = fbBrowser.get(0).contentDocument;
    var iframeBody = self.$(doc.body);

    logger.debug("FacebookLoginManager -> DOM content loaded for URL: " + doc.location);

    if (doc.location == Config.facebookConnectURL) {
      var evt = doc.createEvent('MouseEvents');
      evt.initMouseEvent('click', true, true,
        doc.defaultView, 1, 0, 0, 0, 0, false, false, false, false, 0, null);
      iframeBody.find(".fbHandle").get(0).dispatchEvent(evt);
      return;
    }
    if (doc.location == Config.facebookConnectDoneURL) {
      // Iframe reloaded with session id. FB login done.
      var email = iframeBody.html();
      var user = {email: {"#text": email}};

      var prefs = Utils.getPrefs();
      prefs.setBoolPref("facebookLogin", true);

      callbackObj.on.success(user);
    }
  }

  if (fbBrowser.attr("src")) {
    logger.debug("FacebookLoginManager -> reloading hidden browser");
    fbBrowser.attr("src", Config.facebookConnectURL);
    fbBrowser.get(0).reload(true);
  } else {
    logger.debug("FacebookLoginManager -> setting hidden browser URL attribute");
    fbBrowser.attr("src", Config.facebookConnectURL);
  }

  fbBrowser.get(0).addEventListener("DOMContentLoaded", this.FBPageLoadHandle, false);
  logger.debug("FacebookLoginManager -> authenticate returns");
};

