
var EXPORTED_SYMBOLS = ["GenericLoginManager"];


var Cc = Components.classes;
var Cu = Components.utils;
var Ci = Components.interfaces;


Cu["import"]("resource://extrabux/modules/utils.jsm");
var _txt = Utils.text;


Cu["import"]("resource://extrabux/modules/logging.jsm");
var nativeJSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
Cu["import"]("resource://extrabux/modules/underscore.jsm");

Cu["import"]("resource://extrabux/modules/event.jsm");
Cu["import"]("resource://extrabux/modules/inheritFrom.jsm");
Cu["import"]("resource://extrabux/modules/config.jsm");
Cu["import"]("resource://extrabux/modules/xmlHttpWrapper.jsm");


function GenericLoginManager(browser, $) {
  this._browser = browser;
  this.$ = $;
}


/* Inherit the HTTP voodoo. */
InheritFrom(XMLHTTPWrapper, GenericLoginManager);


GenericLoginManager.prototype.__defineGetter__("id", function() {
  throw "GenericLoginManager id getter must be overridden in a derived class!";
});


GenericLoginManager.prototype.authenticate = function(user, pwd, callbackObj) {
  throw "authenticate must be implemented in derived class!";
};


GenericLoginManager.prototype.create = function(user, pwd, callbackObj) {
  throw "create must be implemented in derived class!";
};


/**
 * Handles the initial login (just creates a dummy user object using the email
 * stored in preferences).
 */
GenericLoginManager.prototype.initialLogin = function(email, callbackObj) {
  var user = {email: {"#text": email}};
  callbackObj.on.success(user);
};


GenericLoginManager.prototype.usedForLastLogin = function() {
  var prefs = Utils.getPrefs();
  var mgrId = prefs.getCharPref("activeLoginManager");

  return (mgrId == this._id);
};


GenericLoginManager.prototype.logout = function(callbackObj) {
  var prefs = Utils.getPrefs();
  prefs.setCharPref("activeLoginManager", "");
  prefs.setCharPref("activeLoginEmail", "");

  callbackObj = callbackObj || {on: {
    success: function() {},
    error: function() {}
  }};

  this._get(Config.logoutURL, {}, 
    {on: {
      success: function() {
        logger.debug("GenericLoginManager -> logged out");
        callbackObj.on.success();
      },
      error: function() {
        callbackObj.on.error();
      }
    }}, false);
};
