
var EXPORTED_SYMBOLS = ["LoginManager"];

var Cc = Components.classes;
var Cu = Components.utils;
var Ci = Components.interfaces;


Cu.import("resource://extrabux/modules/logging.jsm");
var nativeJSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);

var LoginManager = {

  storeLogin: function(username, pwd) {
    var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1",
      Ci.nsILoginInfo, "init");
    var extLoginInfo = new nsLoginInfo(
      'chrome://extrabux', null, 'User Registration',
      username, pwd, "", "");

    var hostname = "chrome://extrabux";
    var formSubmitURL = null;
    var httprealm = 'User Registration';
    var loginManager = Cc["@mozilla.org/login-manager;1"].getService(Ci.nsILoginManager);

    var logins = loginManager.findLogins({}, hostname, formSubmitURL, httprealm);
    if (logins.length > 0) {
      loginManager.removeLogin(logins[0]);
    }
    loginManager.addLogin(extLoginInfo);
  },


  removeLogin: function() {
    var hostname = "chrome://extrabux";
    var formSubmitURL = null;
    var httprealm = 'User Registration';

    var loginManager = Cc["@mozilla.org/login-manager;1"].getService(Ci.nsILoginManager);
    var logins = loginManager.findLogins({}, hostname, formSubmitURL, httprealm);

    if (logins.length > 0) {
      loginManager.removeLogin(logins[0]);
    }
  },


  getLogin: function() {
    var hostname = "chrome://extrabux";
    var formSubmitURL = null;
    var httprealm = 'User Registration';

    try {
       // Get Login Manager
       var loginManager = Cc["@mozilla.org/login-manager;1"].getService(Ci.nsILoginManager);
       // Find users for the given parameters
       var logins = loginManager.findLogins({}, hostname, formSubmitURL, httprealm);
       if (logins.length === 0) {
         return null;
       } else {
         return {
           username: logins[0].username,
           password: logins[0].password
         };
       }
    }
    catch(e) {
      // This will only happen if there is no nsILoginManager component class
      logger.error("LoginManager -> getActiveLogin ->  no nsILoginManager component class");
    }
  }
};

