var EXPORTED_SYMBOLS = ["Restrictions"];

var Cc = Components.classes;
var Cu = Components.utils;
var Ci = Components.interfaces;


Cu.import("resource://extrabux/modules/utils.jsm");
var _txt = Utils.text;


Cu.import("resource://extrabux/modules/logging.jsm");
Cu.import("resource://extrabux/modules/underscore.jsm");

Cu.import("resource://extrabux/modules/inheritFrom.jsm");
Cu.import("resource://extrabux/modules/genericView.jsm");


function Restrictions(window, browser, models, jquery) {
  Restrictions.baseConstructor.call(this, window, browser, models, jquery);

  this._panel = this._cloneTemplatePanel("#extrabux-restrictions-panel-template");
}


InheritFrom(GenericView, Restrictions);


Restrictions.prototype.show = function() {
  this._panel.attr("hidden", false);

  var elem = this._views.NotificationBar.containerElement.find(
    ".extrabux-notif-bar-message-restrictions");
  this._panel.get(0).openPopup(elem.get(0), "after_end", 20, 10);

  var store = this._models.Store.activeStore;
  var restrictions = _txt(store.restrictions);

  var browser = this._panel.find(".extrabux-restrictions-container").get(0);
  this.$(browser.contentDocument.body).children().remove();
  this.$(browser.contentDocument.body).append("<div>" + restrictions + "</div>");

  this._adjustHeight();

  this._visible = true;
};


Restrictions.prototype.hide = function() {
  this._panel.get(0).hidePopup();
  this._visible = false;
};


Restrictions.prototype._adjustHeight = function() {
  var browser = this._panel.find(".extrabux-restrictions-container").get(0);
  var h = this.$(browser.contentDocument.body).find("div").get(0).scrollHeight;
  var margin = 20;
  this._panel.find(
    ".extrabux-restrictions-container").css("height", h + margin);
};


Restrictions.prototype.destroy = function() {
  this._panel.remove();
  this._panel = null;
};
