var EXPORTED_SYMBOLS = ["Store"];


var Ci = Components.interfaces;
var Cc = Components.classes;
var Cu = Components.utils;


Cu.import("resource://extrabux/modules/logging.jsm");
var nativeJSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);


Cu.import("resource://extrabux/modules/underscore.jsm");
Cu.import("resource://extrabux/modules/inheritFrom.jsm");
Cu.import("resource://extrabux/modules/event.jsm");

var models = {};
Cu.import("resource://extrabux/modules/storeCache.jsm", models);


Cu.import("resource://extrabux/modules/config.jsm");
Cu.import("resource://extrabux/modules/utils.jsm");


// Base URL for all Store-API-related requests.
var baseURL = Config.baseURL + "store/";


/*
* The model for stores.
* Wraps the communication with the Extrabux API.
*/
function Store() {
  this.storeCache = models.GlobalStoreCache;

  this._activeStore = null;

  this.activeStoreChanged = new Event(this);
}


/* Extend the prototype. */

Store.prototype.__defineSetter__("activeStore", function(val){
  if (val) {
    this._activeStore = val;
    // Notify the listeners that we have a new activeStore.
    this.activeStoreChanged.notify(val);
  } else {
    this._activeStore = null;
  }
});

Store.prototype.__defineGetter__("activeStore", function(){
  return this._activeStore;
});


/**
 * Updates the activeStore (the one that we're dealing with in the current tab).
 */
Store.prototype.updateActiveStore = function(url) {
  var store = _.detect(this.storeCache.cachedList, function(item) {
    var storeURL = Utils.text(item.store_url);
    return Utils.URLDomainEquals(storeURL, url);
  });
  this.activeStore = store;
};
