
var EXPORTED_SYMBOLS = ["UserAuth"];

var Cc = Components.classes;
var Cu = Components.utils;
var Ci = Components.interfaces;


Cu.import("resource://extrabux/modules/logging.jsm");
var nativeJSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);

Cu.import("resource://extrabux/modules/underscore.jsm");
Cu.import("resource://extrabux/modules/delayedAction.jsm");
Cu.import("resource://extrabux/modules/storage.jsm");
Cu.import("resource://extrabux/modules/loginManager.jsm");


var models = {};
Cu.import("resource://extrabux/modules/user.jsm", models);
Cu.import("resource://extrabux/modules/genericController.jsm");
Cu.import("resource://extrabux/modules/inheritFrom.jsm");


function UserAuth(window, browser, models, views, $) {
  this._document = window.document;

  UserAuth.baseConstructor.call(this, window, browser, models, views, $);

  this.delayedActions = new DelayedAction();
}


InheritFrom(GenericController, UserAuth);


/******* Public methods. *******/

UserAuth.prototype.signupClicked = function() {
  var creds = this._views.UserAuth.getCredentials();
  this._signup(creds.email, creds.pwd);
};


UserAuth.prototype.signinClicked = function() {
  var creds = this._views.UserAuth.getCredentials();
  this._signin(creds.email, creds.pwd);
};


UserAuth.prototype.loginLinkClicked = function() {
  this._views.UserAuth.hide();
  this._views.UserAuth.state = "signin";
  this._views.UserAuth.show();
};

UserAuth.prototype.signupLinkClicked = function() {
  this._views.UserAuth.hide();
  this._views.UserAuth.state = "signup";
  var couponId = this._views.UserAuth.getLinkedCouponId();
  this._views.UserAuth.show(couponId);
};


UserAuth.prototype.cancelClicked = function() {
  this._views.UserAuth.hide();
  this._controllers.Main._generateClick(false);
};


UserAuth.prototype.continueLinkClicked = function(elem) {
  this._views.UserAuth.hide();
  var id = this.$(elem).attr("id");
  this._controllers.CouponList.handleClickWorker(id);
};


/******* Private methods. *******/

UserAuth.prototype._signup = function(email, pwd) {
  var self = this;
  models.GlobalUser.activeLoginManager = "extrabux";
  models.GlobalUser.create(email, pwd, {"on" : {
    "success": function(user) {
      self._signin(email, pwd);
    },
    "error": function(reason) {
      self._views.UserAuth.updateError(reason);
    }
  }});
};


UserAuth.prototype._signin = function(email, pwd) {
  var self = this;
  models.GlobalUser.activeLoginManager = "extrabux";
  models.GlobalUser.authenticate(email, pwd, {"on" : {
    "success": function(user) {
      // Save the credentials.
      self._views.UserAuth.hide();

      self._views.NotificationBar.state = "main";
      self._views.NotificationBar.show();

      // Execute the delayed actions.
      self.delayedActions.fire();
      self.delayedActions.clear();
    },
    "error": function(reason) {
      self._views.UserAuth.updateError(reason);
    }
  }});
};


UserAuth.prototype.facebookLinkClicked = function() {
  var self = this;

  models.GlobalUser.activeLoginManager = "facebook";
  models.GlobalUser.authenticate(null, null, {on: {
    success: function(activeUser) {
      // Execute the delayed actions.
      self.delayedActions.fire();
    },
    error: function() {}
  }});
  this._views.UserAuth.hide();
};
