
EXPORTED_SYMBOLS = ["xml2Json"];

var Ci = Components.interfaces;
var Cc = Components.classes;
var Cu = Components.utils;


Cu.import("resource://extrabux/modules/logging.jsm");
var nativeJSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);


/**
 * Convert XML to JSON Object
 * @param {Object} XML DOM Document
 *
 * Taken from: http://onwebdevelopment.blogspot.com/2008/05/converting-xml-to-json.html
 */
var xml2Json = function(xml) {
  var obj = {};
  if (xml === null) {
    return obj;
  }

  if (xml.nodeType == 1) { // element
    // do attributes
    if (xml.attributes.length > 0) {
      obj['@attributes'] = {};
      for (var j = 0; j < xml.attributes.length; j++) {
        obj['@attributes'][xml.attributes[j].nodeName] = xml.attributes[j].nodeValue;
      }
    }

  } else if (xml.nodeType == 3) { // text
    obj = xml.nodeValue;
  } else if (xml.nodeType == 4) {
    obj = xml.data;
  }

  // do children
  if (xml.hasChildNodes()) {
    for(var i = 0; i < xml.childNodes.length; i++) {
      if (typeof(obj[xml.childNodes[i].nodeName]) == 'undefined') {
        obj[xml.childNodes[i].nodeName] = xml2Json(xml.childNodes[i]);
      } else {
        if (typeof(obj[xml.childNodes[i].nodeName].length) == 'undefined') {
          var old = obj[xml.childNodes[i].nodeName];
          obj[xml.childNodes[i].nodeName] = [];
          obj[xml.childNodes[i].nodeName].push(old);
        }
        if (typeof(obj[xml.childNodes[i].nodeName])=='object') {
          obj[xml.childNodes[i].nodeName].push(xml2Json(xml.childNodes[i]));
        }
      }
    }
  }

  return obj;
};

