var EXPORTED_SYMBOLS = ["XMLHTTPPaginator"];


var Ci = Components.interfaces;
var Cc = Components.classes;
var Cu = Components.utils;

Cu.import("resource://extrabux/modules/inheritFrom.jsm");
Cu.import("resource://extrabux/modules/xmlHttpWrapper.jsm");
Cu.import("resource://extrabux/modules/underscore.jsm");
Cu.import("resource://extrabux/modules/utils.jsm");
Cu.import("resource://extrabux/modules/config.jsm");
Cu.import("resource://extrabux/modules/logging.jsm");
var nativeJSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);


function XMLHTTPPaginator() {
}


InheritFrom(XMLHTTPWrapper, XMLHTTPPaginator);


/*
 * @param url: The URL that we should send the GET request to.
 * @param totalCountPropName: The name of the property that sepcifies total number of items to be downloaded (e.g. "total_stores").
 * @param objName: The name of the property we are downloading (e.g. "store".
 *
 * Note: parameters starting with '_' are supposed to be undefined (call the method without them).
 */
XMLHTTPPaginator.prototype._downloadList = function(url, params,
    totalCountPropName, listObjName, objName, maxResults, callbackObj) {
  this._downloadWorker(
    url, params, totalCountPropName, listObjName, objName, maxResults,
    callbackObj, 1, [], 0);
};


XMLHTTPPaginator.prototype._downloadWorker = function(url, params,
    totalCountPropName, listObjName, objName, maxResults, callbackObj,
    _pageIndex, _accumulator, _lastUpdateAccuLength) {

  params.page = _pageIndex;

  var self = this;

  /* This ugly recursive piece of code handles asynchronous loading of the whole list of objects.*/
  this._get(
    url,
    params,
    {"on" : {
      "success": function(response) {
        var json = response[listObjName][objName];
        if (json) {
          _accumulator = _accumulator.concat(json);
        }
        var totalCount = maxResults || parseInt(
          Utils.text(response.details[totalCountPropName]), 10);
        if (_accumulator.length < totalCount) {
          logger.debug("XMLHTTPPaginator -> downloaded " + _accumulator.length + " of " + totalCount);
          // Send listLoaded notification (but we're not done yet).
          if (_accumulator.length - _lastUpdateAccuLength >= Config.listLoadedStepSize) {
            logger.debug("XMLHTTPPaginator -> sending partial success notification...");
            callbackObj.on.success(_accumulator, false);
            _lastUpdateAccuLength = _accumulator.length;
          }
          self._downloadWorker(url, params, totalCountPropName, listObjName, objName,
            maxResults, callbackObj, _pageIndex + 1, _accumulator, _lastUpdateAccuLength);
        } else {
          // Send listLoaded notification (all is downloaded).
          callbackObj.on.success(_accumulator, true);
        }
      },
      "error": function() {
        callbackObj.on.error();
      }
    }
  });

};

