EXPORTED_SYMBOLS = ["XMLHTTPWrapper"];

var Ci = Components.interfaces;
var Cc = Components.classes;
var Cu = Components.utils;

Components.utils.import("resource://extrabux/modules/logging.jsm");
var nativeJSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);

Components.utils.import("resource://extrabux/modules/xml2json.jsm");
Components.utils.import("resource://extrabux/modules/inheritFrom.jsm");
Components.utils.import("resource://extrabux/modules/httpWrapper.jsm");
Cu.import("resource://extrabux/modules/utils.jsm");
var _txt = Utils.text;


/**
 * Base class for dealing with HTTP XML requests.
 **/
function XMLHTTPWrapper() {
}

InheritFrom(HTTPWrapper, XMLHTTPWrapper);


XMLHTTPWrapper.prototype._handleStateChange = function(req, callbackObj, evt) {
  if (req.readyState == 4) {
    var json = xml2Json(req.responseXML);
    if(req.status == 200) {
      logger.info("XMLHTTPWrapper -> request success -> response XML: " + nativeJSON.encode(json.response));
      callbackObj.on.success(json.response);
    } else {
      logger.debug("XMLHTTPWrapper -> request error: " + nativeJSON.encode(json.response));
      if (json.response) {
        callbackObj.on.error(_txt(json.response.error));
      }
    }
  }
};

